package com.scala.master

import jdk.nashorn.internal.ir.WhileNode
import org.antlr.v4.runtime._
import org.antlr.v4.runtime.InputMismatchException

import java.io.ByteArrayInputStream
import java.util.Scanner
import scala.util.Try


object ScalaParser {

  def main(args: Array[String]): Unit = {

      val scanner = new Scanner(System.in)

       while (scanner.hasNext()) {

           val input: String = scanner.nextLine()
           val inputStream = CharStreams.fromStream(new ByteArrayInputStream(input.getBytes("utf-8")))
           val syntaxLexer = new SyntaxLexer(inputStream)
           val syntaxTokens = new CommonTokenStream(syntaxLexer)
           val syntaxParser = new SyntaxParser(syntaxTokens)

           syntaxParser.setBuildParseTree(true)


           syntaxParser.addErrorListener(new SyntaxGrammarError)
           syntaxParser.addParseListener(new SyntaxGrammarListener)

           syntaxParser.formula()


           class SyntaxGrammarError extends BaseErrorListener {

             override def syntaxError(recognizer: Recognizer[_, _], offendingSymbol: Any, line: Int, charPositionInLine: Int, msg: String, e: RecognitionException): Unit = {
               super.syntaxError(recognizer, offendingSymbol, line, charPositionInLine, msg, e)
             }
           }

           class SyntaxGrammarListener extends SyntaxBaseListener {

             override def exitFormula(ctx: SyntaxParser.FormulaContext): Unit = {

               super.exitFormula(ctx)
               println(ctx.toStringTree(syntaxParser))
             }
           }

       }


         }

}
