grammar Syntax;

IndividualVariable: [u-z];
SequenceVariable: [U-Z];
variable: IndividualVariable | SequenceVariable;

RankedFunctionSymbol: [f-h];
UnrankedFunctionSymbol: [F-H];
functionSymbol: RankedFunctionSymbol | UnrankedFunctionSymbol;

RankedPredicateSymbol: [p-r];
UnrankedPredicateSymbol: [P-R];
predicateSymbol: RankedPredicateSymbol | UnrankedPredicateSymbol;

falsumPropositionalConstant: '0';
logicalConnective: 'L->' | 'P->' | 'P^';
quantifier: 'All' | 'Exists';

individualTerm: IndividualVariable | RankedFunctionSymbol individualTermList | UnrankedFunctionSymbol list;
sequenceTerm: SequenceVariable | list;
term: individualTerm | sequenceTerm;

list: '(' ( term (',' term)* ) ')';
individualTermList: '(' ( individualTerm (',' individualTerm)* ) ')';

atom: RankedPredicateSymbol individualTermList | UnrankedPredicateSymbol list;
formula: atom | falsumPropositionalConstant | '(' formula logicalConnective formula ')' | '(' quantifier variable ')' formula;

WS: [ \t\r\n] -> skip;


